package com.fp.persistence.parmas.soli;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMTRANSACCIONARMABODEGA*/
@Entity(name="TarmTransaccionArmaBodega")
@Table(name="TARMTRANSACCIONARMABODEGA")
public class TarmTransaccionArmaBodega extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmTransaccionArmaBodega
*/
@Id
@Column(name="CTRANARMBODEGA" ,nullable=false, updatable=false)
/*@GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SequenceKey", parameters = {
        @Parameter(name = "name", value = "CTRANARMBODEGA"),//campo secuencial de la tabla
        @Parameter(name = "type", value = "java.lang.Long"),// tipo de dato
        @Parameter(name = "fill", value = "0"),
        @Parameter(name = "length", value = "16")})
    @GeneratedValue(generator = "seq_id")*/
private Long pk;
@Column(name="FECHA", nullable=true)

/**
* fecha de registro
*/
private Timestamp fecha;

@Column(name="CDECOMISOARMATRANSACCION", nullable=true)

/**
* codigo de la tabla tarmdecomisoarmatransaccion, se genera el codigo de envio y recepcion
*/
private Long cdecomisoarmatransaccion;

@Column(name="CARMA", nullable=true)

/**
* codigo del arma
*/
private String carma;

@Column(name="OPERACION", nullable=true)

/**
* Codigo de catalogo  01Recepcion, 02 Envio
*/
private String operacion;

@Column(name="OPERACIONCODE", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de operaciones
*/
private String operacioncode;

@Column(name="CCENTROCONTROLORIGEN", nullable=true)

/**
* Codigo de centro de control de armas, bodega de origen
*/
private String ccentrocontrolorigen;

@Column(name="CCENTROCONTROLDESTINO", nullable=true)

/**
* Codigo de centro de control de armas, bodega destino
*/
private String ccentrocontroldestino;

/**Contructor por defecto*/
public TarmTransaccionArmaBodega(){
}
/**Contructor de TarmTransaccionArmaBodega
@param pPk Clave Primaria del entity
*/
public TarmTransaccionArmaBodega(Long pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmTransaccionArmaBodega
*/
public static TarmTransaccionArmaBodega find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmTransaccionArmaBodega obj = pEntityManager.find(TarmTransaccionArmaBodega.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmTransaccionArmaBodega
@return El objeto que referencia a la Clave primaria de TarmTransaccionArmaBodega
*/
public Long getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmTransaccionArmaBodega
@param pPk El objeto que referencia a la nueva Clave primaria de TarmTransaccionArmaBodega
*/
public void setPk(Long pPk){
  pk=pPk;
}
/**Obtiene el valor de fecha
@return valor de fecha*/
public Timestamp getFecha(){
  return fecha;
}
/**Fija el valor de fecha
@param pFecha nuevo Valor de fecha*/
public void setFecha(Timestamp pFecha){
  fecha=pFecha;
}

/**Obtiene el valor de cdecomisoarmatransaccion
@return valor de cdecomisoarmatransaccion*/
public Long getCdecomisoarmatransaccion(){
  return cdecomisoarmatransaccion;
}
/**Fija el valor de cdecomisoarmatransaccion
@param pCdecomisoarmatransaccion nuevo Valor de cdecomisoarmatransaccion*/
public void setCdecomisoarmatransaccion(Long pCdecomisoarmatransaccion){
  cdecomisoarmatransaccion=pCdecomisoarmatransaccion;
}

/**Obtiene el valor de carma
@return valor de carma*/
public String getCarma(){
  return carma;
}
/**Fija el valor de carma
@param pCarma nuevo Valor de carma*/
public void setCarma(String pCarma){
  carma=pCarma;
}

/**Obtiene el valor de operacion
@return valor de operacion*/
public String getOperacion(){
  return operacion;
}
/**Fija el valor de operacion
@param pOperacion nuevo Valor de operacion*/
public void setOperacion(String pOperacion){
  operacion=pOperacion;
}

/**Obtiene el valor de operacioncode
@return valor de operacioncode*/
public String getOperacioncode(){
  return operacioncode;
}
/**Fija el valor de operacioncode
@param pOperacioncode nuevo Valor de operacioncode*/
public void setOperacioncode(String pOperacioncode){
  operacioncode=pOperacioncode;
}

/**Obtiene el valor de ccentrocontrolorigen
@return valor de ccentrocontrolorigen*/
public String getCcentrocontrolorigen(){
  return ccentrocontrolorigen;
}
/**Fija el valor de ccentrocontrolorigen
@param pCcentrocontrolorigen nuevo Valor de ccentrocontrolorigen*/
public void setCcentrocontrolorigen(String pCcentrocontrolorigen){
  ccentrocontrolorigen=pCcentrocontrolorigen;
}

/**Obtiene el valor de ccentrocontroldestino
@return valor de ccentrocontroldestino*/
public String getCcentrocontroldestino(){
  return ccentrocontroldestino;
}
/**Fija el valor de ccentrocontroldestino
@param pCcentrocontroldestino nuevo Valor de ccentrocontroldestino*/
public void setCcentrocontroldestino(String pCcentrocontroldestino){
  ccentrocontroldestino=pCcentrocontroldestino;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmTransaccionArmaBodega))return false;
    TarmTransaccionArmaBodega that = (TarmTransaccionArmaBodega) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmTransaccionArmaBodega
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmTransaccionArmaBodega
*/
public Object createInstance(){
 TarmTransaccionArmaBodega instance=new TarmTransaccionArmaBodega();	
 return instance;
}
/**Clona la entidad TarmTransaccionArmaBodega
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmTransaccionArmaBodega p=(TarmTransaccionArmaBodega)this.clone();
  return p;
}
}
